from kivy.utils import platform
from kivy.uix.widget import Widget

from kivy.app import App

from kivy.core.window import Window
from kivy.config import Config

class Hello2Widget(Widget):
    pass


class Hello2App(App):

    def build(self):
        self.keyboard = Window.request_keyboard(None, self)
        self.keyboard.bind(on_key_down=self._on_key_down)
        return Hello2Widget()

    def _on_key_down(self, keyboard, keycode, text, modifiers):
        print Window.width, Window.height
        print 'You selected', self.config.getdefault('hello', 'selection', 'Nothing')
        if keycode[1].upper() == 'Q':
            self.stop()

    def build_config(self, config):
        config.setdefaults('hello', {'selection': 'Nothing'}) 

    def build_settings(self, settings):
        config_json = """[
            {  "type": "title",
               "title": "A Hello World App"
            },

            {  "type": "options",
               "title": "Something to select",
               "section": "hello",
               "key": "selection",
               "options": ["A thing", "Another thing", "Something else"]
            }
            ]"""
        settings.add_json_panel("Hello World", self.config, data=config_json)


if __name__ == "__main__":
   Hello2App().run()
